import "ExoPlugins.AssistantParse";

function LoadPlugin()
    Player = Turbine.Gameplay.LocalPlayer.GetInstance();
    Callbacks = {};
    SkillList = Player:GetTrainedSkills();
    SkillsTable = {};
    Settings = {};
    Updater = Updater();
    Font = ConfigureFontTwo();
    CombatStartTime = 0;
    SkillCount = 0;
    if Turbine.PluginData.Load(Turbine.DataScope.Character, "AssistantParseSettings") == nil then
        Settings = {
            ["General"] = {
                ["Position"] = {
                    [1] = 0;
                    [2] = 0;
                }
            }
        }
    else
        Settings = LoadData(Turbine.DataScope.Character, "AssistantParseSettings");
    end
    local screenWidth, screenHeight = Turbine.UI.Display:GetSize();
    SkillWindow = SkillWindow(Settings["General"]["Position"][1]*screenWidth, Settings["General"]["Position"][2]*screenHeight);
	for i = 1, SkillList:GetCount(), 1 do
		local item = SkillList:GetItem(i);
		local name = item:GetSkillInfo():GetName();
		local ID = item:GetSkillInfo():GetIconImageID();

		Callbacks[name] = {}

        SkillsTable[name] = item
		table.insert(Callbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args)
            SkillWindow:AddSkill(ID);
            SkillCount = SkillCount + 1;
		end));
	end

    --Workaround for Hunters. Since QS has no CD we need to track combat log.
    if GetClass(Player) == "Hunter" then
        ChatHandler = Turbine.Chat;
        ChatListener = function(f, args)
            if args ~= nil then
                if args.ChatType == Turbine.ChatType.PlayerCombat then
                    local source,_,skillName,target,_ = string.match(string.gsub(string.gsub(args["Message"],"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
                    if skillName ~= nil then
                        if string.find(skillName, "Quick Shot") then
                            SkillWindow:AddSkill(1090553925);
                            SkillCount = SkillCount + 1;
                        end
                    end
                end
            end
        end
        AddCallback(ChatHandler, "Received", ChatListener);
    end

    --Just checking if we're currently in combat when loading plugin, mostly for my own test stuff
    if Player:IsInCombat() == true then
        SkillCount = 0;
        CombatStartTime = Turbine.Engine.GetGameTime();
        AddCallback(Updater, "Tick", SkillWindow.UpdateAPM);
    end

    CombatHandler = function(f, args)
        if Player:IsInCombat() == true then
            SkillCount = 0;
            CombatStartTime = Turbine.Engine.GetGameTime();
            AddCallback(Updater, "Tick", SkillWindow.UpdateAPM);
        else
            RemoveCallback(Updater, "Tick", SkillWindow.UpdateAPM);
        end
    end
    AddCallback(Player, "InCombatChanged", CombatHandler)


end

LoadPlugin();

function UnloadPlugin()
    SaveData(Turbine.DataScope.Character, "AssistantParseSettings", Settings);
    for key, value in pairs(Callbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(SkillsTable[key], "ResetTimeChanged", callback);
        end
    end
    if GetClass(Player) == "Hunter" then
        RemoveCallback(ChatHandler, "Received", ChatListener);
    end
end

plugin.Load=function(sender, args)
	Turbine.Shell.WriteLine("<rgb=#FF5555><" .. plugin:GetName() .. "></rgb> V." .. plugin:GetVersion() .. " loaded.");
end

plugin.Unload=function()
    UnloadPlugin();
	Turbine.Shell.WriteLine("<rgb=#FF5555><AssistantParse></rgb> Unload Complete");
end