SkillWindow = class(Turbine.UI.Window)
function SkillWindow:Constructor(X, Y)
    Turbine.UI.Window.Constructor(self)
    self:SetMouseVisible(false);
	self:SetVisible(true);
    self:SetPosition(X, Y);
    self.count = 5;
    self:SetSize(self.count*32, 50);
    SkillIcons = {};

    for i = 0,self.count-1,1 do 
        SkillIcons[i] = SkillIcon("ExoPlugins/AssistantParse/Resources/blank.tga", self, i*32);
    end

    self.APM = APMCounter();
    self.APM:SetParent(self);
    self.APM:SetSize(self.count*32, 18);
    self.APM:SetPosition(0,32);

    self.UpdateAPM = function ()
        self.APM:SetAPM();
    end


    self.DragBar = DragBar( self, "AssistantParse" );
end

function SkillWindow:AddSkill(iconID)
    for i = 0,self.count-2,1 do 
        SkillIcons[i]:SetIcon(SkillIcons[i+1]:GetIcon());
    end
    SkillIcons[self.count-1]:SetIcon(iconID);
end

function SkillWindow:SavePosition()
	local screenWidth, screenHeight = Turbine.UI.Display:GetSize();
	Data = {
		[1] = self:GetLeft()/screenWidth,
		[2] = self:GetTop()/screenHeight,
	};

	Settings["General"]["Position"] = Data;
end

SkillIcon = class(Turbine.UI.Control)
function SkillIcon:Constructor(Icon, parent, xPos)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(32, 32);
    self:SetParent(parent);
    self:SetLeft(xPos);
    self:SetBackground(Icon);
end

function SkillIcon:GetIcon()
    return self:GetBackground();
end

function SkillIcon:SetIcon(icon)
    self:SetBackground(icon);
end

APMCounter = class(Turbine.UI.Window)
function APMCounter:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetMouseVisible(false);
	self:SetVisible(true);

    self.Text = TextDisplay();
    self.Text:SetParent(self);
    self.Text:SetWidth(5*32);
    self.Text:SetTextScale(0.3);
    self.Text:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.Text:SetText("APM: N/A");
end

function APMCounter:SetAPM()
    self.Text:SetText("APM: " .. Round(CalculateAPM(),0));
end